/*
 * Title: Individulni Floyi
 *
 * Description:
 *
 * Author: Peter Palkovi 2006
 * 
 */

import java.applet.*;
import java.awt.*;
import java.net.*;
import javax.swing.*;
import javax.swing.border.TitledBorder;
import javax.swing.border.Border;
import javax.swing.event.*;
import java.awt.event.*;


class GfloyParam {

	float min;
	float max;
	float step;
	float value;
	int nsteps;
	String name;

	public GfloyParam(float mn, float mx, float st, float vl, String nm) {

		min = mn;
		max = mx;
		step = st;
		name = nm;
		value = vl;

		nsteps = (int) ((mx-mn)/step);

	}

	public GfloyParam (float mn, float mx, int ns, float vl, String nm) {

		min = mn;
		max = mx;
		nsteps = ns;
		name = nm;
		value = vl;

		step = (float) ((mx-mn)/nsteps);

	}

	char EncodeValue() {

		int n = (int) ((value - min)/step);
		char k = (char) (64+n);
		return k;

	}

	float DecodeValue(char kar) {

		int n = (int) (kar - 64);
		float k = value + n*step;
		return k;

	}

}


class GfloyCanvas extends Canvas
{
	Image image;
	Color color;
	boolean first;
	boolean reset;


	public GfloyCanvas(Image img)	{

		super();
 		image = img;
		color = Color.white;
		setBackground(Color.white);
		setForeground(Color.black);
		first = true;
		reset = false;

	}

	public GfloyCanvas(Color c)	{

		super();
 		image = null;
 		
		setBackground(Color.white);
		setForeground(Color.black);
		color = c;
		first = true;
		reset = false;

	}

	public void Clear() {

		reset = true;
		repaint();

	}


	public void paint(Graphics g) {

		int i;
		Gfloy Gfloy;

		if (reset) {
			g.setColor(Color.white);
			g.fillRect(0,0,size().width,size().height);
			reset = false;
			return;
		}

		if (image != null)
			g.drawImage(image,0,0,this);
		else {
		}

		for (i=0;i<Gfloys.Gfloys.length;i++)
	 	{
			Gfloy = Gfloys.Gfloys[i];
			Gfloy.GetNeighbors();
	 		Gfloy.Process();
			Gfloy.Draw(g);
	 	}


	}

	Graphics GetGra() {

		return this.getGraphics();
	}
}

public class Gfloys extends Applet implements Runnable {  //hlavna trieda

	Thread runner;
	GfloyCanvas canvas;
	GfloyControl fcontrol;
	static Gfloy[] Gfloys;

    JPanel pnlVotrelec = new JPanel();
    TitledBorder titledBorder3 = new TitledBorder("");

    Border border1 = BorderFactory.createEtchedBorder(Color.white,new Color(156, 156, 158));
    Border border2 = new TitledBorder(border1, "Model prostredia");

    Border border3 = BorderFactory.createEtchedBorder(Color.white,new Color(156, 156, 158));
    Border border4 = new TitledBorder(border3, "Votrelec");

    JPanel pnlModel = new JPanel();
    ButtonGroup rbtnEnviroment = new ButtonGroup();
    JRadioButton rbtnEnviromentToroid = new JRadioButton("Toroid");
    JRadioButton rbtnEnviromentBounded = new JRadioButton("Ohranien");

	JComboBox cmbSpravanie = new JComboBox();

    JPanel pnlVlastnostii = new JPanel();
    JPanel pnlVlastnosti = new JPanel();
    JPanel pnlTlacitka = new JPanel();
	JButton Pause = new JButton();
	JButton Control = new JButton();;
	JButton Default = new JButton();
	JButton Pridat = new JButton();
	JButton Odobrat = new JButton();
    static JLabel lbStatus = new JLabel();
    JLabel lbRychlost = new JLabel();
	JSlider sldRychlost = new JSlider();
    JLabel lbPocet = new JLabel();
	JSlider sldPocet = new JSlider();
	Graphics gra;
	Panel ControlPanel;
	GfloyParam params[];
	Font ButtonFont;
	

	int wa,ha,wc,hc;
	int CurrentBehavior;
	boolean running;
	static boolean First;
	static boolean ResetPopulation = true;

	static int NF;
	static int REVDIST;
	static float ACC;
	static float ACCTOMID;	
	static float MAXSPEED;
	static float BOUNCESPEED;
	static float V0;
	static float KICK;
	static int SLEEP;
	static int MARGIN;
	static int NUMNB;
	static int TYPE;
	static String COLOR = "ierna";
	static boolean Nastavenia;

    static Image picture;
    static AppletContext appcontext;


	public void init() {  //inicializcia
		int i;
		Float temp;
		String s;

		ButtonFont = new Font("TimesRoman",Font.PLAIN,12);
		reset();
//nastavenie parametrov
		s=getParameter("NF");
		if (s==null)
			NF=10;
		else NF = Integer.parseInt(s);
		s=getParameter("REVDIST");
		if (s==null)
			REVDIST=200;
		else REVDIST = Integer.parseInt(s);
		s=getParameter("ACCTOMID");
		if (s==null)
			ACCTOMID=0.1f;
		else {
				temp=new Float(s);
				ACCTOMID = temp.floatValue();
			}
		s=getParameter("ACC");
		if (s==null)
			ACC=0.3f;
		else {
				temp=new Float(s);
				ACC = temp.floatValue();
			}
		s=getParameter("MAXSPEED");
		if (s==null)
			MAXSPEED=5f;
		else {
				temp=new Float(s);
				MAXSPEED = temp.floatValue();
			}
		s=getParameter("BOUNCESPEED");
		if (s==null)
			BOUNCESPEED=.8f;
		else {
				temp=new Float(s);
				BOUNCESPEED = temp.floatValue();
		}

//inicializcia komponentov

		setLayout(new BorderLayout( 5, 20));
		setBackground(Color.lightGray);
		

		Panel bot = new Panel();
		bot.setLayout(new BorderLayout(10,0));
		bot.setBackground(Color.lightGray);
		
		  Panel bot_left = new Panel();
		  bot_left.setLayout(new GridLayout(5,1,0,0));


        pnlModel.setBackground(Color.lightGray);
        pnlModel.setBorder(border2);       
        pnlModel.setPreferredSize(new Dimension(200, 50));
        pnlModel.setBounds(new Rectangle(0, 105, 200, 50));
        pnlModel.setLayout(new GridLayout (1,2,2,2));
        rbtnEnviromentToroid.addActionListener(new NastavitToroid(this));		//prid listener na radio button toroid
        rbtnEnviromentBounded.addActionListener(new NastavitOhraniceny(this));	//prid listener na radio button ohraniceny
		

        pnlVotrelec.setBackground(Color.lightGray);
        pnlVotrelec.setBorder(border4);
        pnlVotrelec.setPreferredSize(new Dimension(200, 100));
        pnlVotrelec.setBounds(new Rectangle(0, 160, 200, 60));
        pnlVotrelec.setLayout(new GridLayout (1,2,2,2));

		cmbSpravanie.addItem("tandartn sprvanie");
		cmbSpravanie.addItem("Pokojn sprvanie");
		cmbSpravanie.addItem("Aktvne sprvanie");
		cmbSpravanie.addItem("Zriv sprvanie");
		cmbSpravanie.setSelectedItem("tandartn sprvanie");
		Spravanie actionListener = new Spravanie();
    	cmbSpravanie.addActionListener(actionListener); //prid listener na combobox sprvanie
    	
    	
        pnlTlacitka.setBackground(Color.lightGray);
        pnlTlacitka.setLayout(new GridLayout(3,1,0,1));

        pnlVlastnostii.setBackground(Color.lightGray);
        pnlVlastnostii.setPreferredSize(new Dimension(200, 110));
        pnlVlastnostii.setBounds(new Rectangle(0, 0, 200, 110));
        pnlVlastnostii.setLayout(new GridLayout(3,1,1,1));
        pnlVlastnosti.setBackground(Color.lightGray);
        pnlVlastnosti.setPreferredSize(new Dimension(200, 110));
        pnlVlastnosti.setBounds(new Rectangle(0, 0, 200, 110));
        pnlVlastnosti.setLayout(new GridLayout(4,1,0,0));

        lbStatus.setBounds(new Rectangle(18, 60, 110, 15));
        lbStatus.setText("tandartn sprvanie");

        lbRychlost.setText("Rchlos : 50%");
        lbRychlost.setBounds(new Rectangle(17, 10, 100, 15));

		sldRychlost.setBackground(Color.lightGray);
        sldRychlost.setPreferredSize(new Dimension(180, 20));
        sldRychlost.setBounds(new Rectangle(10, 30, 180, 20));
        sldRychlost.addChangeListener(new RychlostAction(this));				//prid listener na slider rychlost
        sldRychlost.setMaximum(100);												//nastavenie vlastnosti slideru Rychlost
        sldRychlost.setMinimum(1);
        sldRychlost.setValue(80);
        

        lbPocet.setText("Poet jedincov: 10");
        lbPocet.setBounds(new Rectangle(18, 60, 110, 15));
        sldPocet.setMinimum(2);													//nastavenie vlastnosti slideru Pocet jedincov
        sldPocet.setMaximum(50);
        sldPocet.setValue(10);

		sldPocet.setBackground(Color.lightGray);
        sldPocet.setPreferredSize(new Dimension(180, 20));
        sldPocet.setBounds(new Rectangle(10, 30, 180, 20));
        sldPocet.addChangeListener(new PocetAction(this));						//prid listener na slider pocet jedincov


		Pause.setPreferredSize(new Dimension(150, 25));
        Pause.setText("Pauza");
        Pause.setBounds(new Rectangle(25, 315, 150, 25));
        Pause.addActionListener(new PauseAction(this));						//prid listener na tlacitko Pauza


		Control.setPreferredSize(new Dimension(150, 25));
        Control.setText("Vlastnosti");
        Control.setBounds(new Rectangle(25, 315, 150, 25));
        Control.addActionListener(new ControlAction(this));						//prid listener na tlacitko Vlastnosti
        
		Default.setPreferredSize(new Dimension(150, 25));
        Default.setText("tandartn nastavenia");
        Default.setBounds(new Rectangle(25, 315, 150, 25));
        Default.addActionListener(new DefaultAction(this));						//prid listener na tlacitko tandartn nastavenia

		Odobrat.setPreferredSize(new Dimension(150, 25));
        Odobrat.setText("Odober");
        Odobrat.setBounds(new Rectangle(25, 315, 150, 25));
        Odobrat.addActionListener(new OdobratAction(this));						//prid listener na tlacitko Odober

		Pridat.setPreferredSize(new Dimension(150, 25));
        Pridat.setText("Pridaj");
        Pridat.setBounds(new Rectangle(25, 315, 150, 25));
        Pridat.addActionListener(new PridatAction(this));						//prida listener na tlacitko Pridaj

		
	
		bot.setFont(ButtonFont);

        rbtnEnviromentBounded.setSelected(true);
        rbtnEnviromentToroid.setBounds(0 ,0 ,60 ,20);
        rbtnEnviromentBounded.setBounds(0 ,0 ,90 ,20);
        rbtnEnviromentToroid.setLocation(10 ,20);
        rbtnEnviromentBounded.setLocation(100, 20);
        rbtnEnviromentToroid.setBackground(Color.lightGray);
        rbtnEnviromentBounded.setBackground(Color.lightGray); 

        rbtnEnviroment.add(rbtnEnviromentToroid);
        rbtnEnviroment.add(rbtnEnviromentBounded);


        pnlModel.add(rbtnEnviromentToroid);
        pnlModel.add(rbtnEnviromentBounded);


        pnlVotrelec.add(Pridat);
        pnlVotrelec.add(Odobrat);

		  pnlVlastnosti.add(lbRychlost);
		  pnlVlastnosti.add(sldRychlost);
		  pnlVlastnosti.add(lbPocet);
		  pnlVlastnosti.add(sldPocet);

  			bot_left.add(pnlVlastnosti);
			bot_left.add(pnlModel);
  			bot_left.add(pnlVotrelec);



		  pnlTlacitka.add(Control);
		  pnlTlacitka.add(Default);
		  pnlTlacitka.add(Pause);

          pnlVlastnostii.add(cmbSpravanie);

  			bot_left.add(pnlTlacitka);
  			bot_left.add(pnlVlastnostii);


		
		bot.add("Center",bot_left);
		
		  Panel bot_right = new Panel();
		  
		bot.add("East",bot_right);
		
		add("East",bot);
		
                

	    appcontext = getAppletContext();
		picture = getImage(getCodeBase(),"Gfloys1.gif");
		
		
		Panel bot_1 = new Panel();
		bot_1.setLayout(new GridLayout(1,1,0,0));
		  Panel bot_1in = new Panel();
		  bot_1.add(lbStatus);		
		add("South",bot_1);
		
		Panel bot_2 = new Panel();
		bot_2.setLayout(new GridLayout(1,1,0,0));
		  Panel bot_2in = new Panel();
		add("North",bot_2);
		
		Panel bot_3 = new Panel();
		bot_3.setLayout(new GridLayout(1,1,10,10));
		  Panel bot_3in = new Panel();
		  bot_3.add(bot_3in);		
		add("West",bot_3);
		
		

		canvas = new GfloyCanvas(Color.red);
		add("Center",canvas);
		canvas.repaint();
		gra = canvas.GetGra();

		CurrentBehavior = 0;
		First = true;

	}

	public void start()
	{
		if (runner == null)
		{
			runner= new Thread(this);
			runner.start();
			running = true;
		}
	}
	
	public void stop()
	{
		if (runner!=null)
		{
			runner.stop();
			runner=null;
			running = false;
		}
	}

	public void run() {

		int i;
		Gfloy Gfloy;

		if (First) {
			hc = canvas.size().height;
			wc = canvas.size().width;
			ha = this.size().height;
			wa = this.size().width;
			String st = EncodeChrom();
			if (ResetPopulation) {
				Gfloys = new Gfloy[NF];
				for (i=0;i<NF;i++) {
						Gfloys[i] = new Gfloy(st,i, wc,hc,0,200,GetColorByString(COLOR));
						Gfloys[i].ohraniceny = true;
				        rbtnEnviromentBounded.setSelected(true);


				}
			}
		
			randemize();
			First = false;
		}
	
		gra.setColor(Color.white);
		while (true) {
		 	if (Math.random()< (double) KICK) randemize();
		 	canvas.repaint();
		 	try { Thread.sleep(SLEEP);}
		 	catch (InterruptedException e) {}
		}
		

	}
	public Color GetColorByString(String c) {

		Color col;

		if (c.equals("ierna")) col = Color.black;
		else if (c.equals("Modr")) col = Color.blue;
		else if (c.equals("Zelenomodr")) col = Color.cyan;
		else if (c.equals("Tmavoed")) col = Color.darkGray;
		else if (c.equals("ed")) col = Color.gray;
		else if (c.equals("Zelen")) col = Color.green;
		else if (c.equals("Svetloed")) col = Color.lightGray;
		else if (c.equals("Oranov")) col = Color.orange;
		else if (c.equals("Ruov")) col = Color.pink;
		else if (c.equals("erven")) col = Color.red;
		else if (c.equals("Biela")) col = Color.white;
		else if (c.equals("lt")) col = Color.yellow;
		else col = Color.black;

		return col;

	}

	public void randemize()
	{
		int i,j,k,n;

		for (k=0;k<NF;k++) {
			Gfloy ng = Gfloys[k];
			for (j=0;j<ng.numnb;j++) {
				n =(int) (Math.random()*NF);
				ng.neighbors[j] = Gfloys[n];
			}
		}
	}


	String EncodeChrom() {

		char kars[];
		String st;

		kars = new char[10];

		kars[0] = (char) ((int) ((int) REVDIST/10) + 64);
		kars[1] = (char) ((int) (64 + ACC*100));
		kars[2] = (char) ((int) (64 + ACCTOMID*100));
		kars[3] = (char) ((int) (64 + MAXSPEED*10));
		kars[4] = (char) ((int) (64 + BOUNCESPEED*100));
		kars[5] = (char) ((int) (64 + V0*10));
		kars[6] = (char) (SLEEP + 64);
		kars[7] = (char) (MARGIN + 64);
		kars[8] = (char) ((int) (64 + NUMNB*10));
		kars[9] = (char) ((int) (64 + TYPE*100));

		st = new String(kars);
		return st;

	}


	void InitParams() {

		params = new GfloyParam[10];

		params[0] = new GfloyParam(0f,500f,50f,200f,"REVDIST");
		params[1] = new GfloyParam(0.1f,1.0f,0.1f,0.3f,"ACC");
		params[2] = new GfloyParam(0.1f,1.0f,0.1f,0.1f,"ACCTOMID");
		params[3] = new GfloyParam(1f,10f,1f,5f,"MAXSPEED");
		params[4] = new GfloyParam(0.2f,2f,0.2f,0.8f,"BOUNCESPEED");
		params[5] = new GfloyParam(1f,10f,1f,4f,"V0");
		params[6] = new GfloyParam(5f,50f,5f,10f,"SLEEP");
		params[7] = new GfloyParam(0f,50f,5f,30f,"MARGIN");
		params[8] = new GfloyParam(0f,10f,1f,2f,"NUMNB");
		params[9] = new GfloyParam(0f,1f,1f,0f,"TYPE");
		

	}


	String EncodeChrom(GfloyParam params[]) {

		int i;
		char kar;
		String st;
		StringBuffer sb = new StringBuffer(params.length);

		for (i=0;i<params.length;i++) {
			kar = params[i].EncodeValue();
			sb.append(kar);
		}

		st = sb.toString();
		return st;

	}


	static public void reset() {

		COLOR = "ierna";
		NF = 10;
		REVDIST = 200;
		ACC = 0.3f;
		ACCTOMID = 0.1f;	
		MAXSPEED = 5f;
		BOUNCESPEED = 0.8f;
		V0 = 4;
		KICK = (float) 0.05;
		SLEEP = 20;
		MARGIN = 30;
		NUMNB = 2;
		TYPE = 0;


	}


	private void ChangeBehavior(int num) {

		switch (num) {
			case 0:	{
				REVDIST = 200;
				ACC = 0.3f;
				ACCTOMID = 0.1f;	
				MAXSPEED = 5f;
				BOUNCESPEED = 0.8f;
				V0 = 4;
				KICK = (float) 0.05;
				MARGIN = 30;
				NUMNB = 2;
				showStatus("tandartn sprvanie");
  	            lbStatus.setText("tandartn sprvanie");   	  
				break;
			}
			case 1:	{
				REVDIST = 200;
				ACC = 0.05f;
				ACCTOMID = 0.05f;	
				MAXSPEED = 3f;
				BOUNCESPEED = 0.5f;
				V0 = 4;
				KICK = (float) 0.05;
				MARGIN = 30;
				NUMNB = 2;
				showStatus("Pokojn sprvanie");
  	            lbStatus.setText("Pokojn sprvanie");   	  
				break;
			}
			case 2:	{
				REVDIST = 200;
				ACC = 0.6f;
				ACCTOMID = 0.2f;	
				MAXSPEED = 5f;
				BOUNCESPEED = 0.8f;
				V0 = 4;
				KICK = (float) 0.05;
				MARGIN = 30;
				NUMNB = 2;
				showStatus("Aktvne sprvanie");
  	            lbStatus.setText("Aktvne sprvanie");   	  
				
				break;
			}
			case 3:	{
				REVDIST = 100;
				ACC = 0.9f;
				ACCTOMID = 0.4f;	
				MAXSPEED = 10f;
				BOUNCESPEED = 2.0f;
				V0 = 4;
				KICK = (float) 0.05;
				MARGIN = 30;
				NUMNB = 2;
				showStatus("Zriv sprvanie");
  	            lbStatus.setText("Zriv sprvanie");   	  
				break;
			}

		}

	}
//-------------------------- Triedy na osetrenie akcii tlacitok a ostatnych komponentov na ploche ---------------------------------


  class Spravanie implements ActionListener {
        public void actionPerformed(ActionEvent evt) {
            JComboBox cmbSpravanie = (JComboBox)evt.getSource();
    
            if ("comboBoxChanged".equals(evt.getActionCommand())) {
            				
            String Zvolene = (String)cmbSpravanie.getSelectedItem();
            if (Zvolene == "tandartn sprvanie") CurrentBehavior = 0;
            if (Zvolene == "Pokojn sprvanie") CurrentBehavior = 1;
            if (Zvolene == "Aktvne sprvanie") CurrentBehavior = 2;
            if (Zvolene == "Zriv sprvanie") CurrentBehavior = 3;
            
			ChangeBehavior(CurrentBehavior);

			stop();
			First = true;
			start();
            	
            }
        }
    }
    



 public class NastavitToroid extends AbstractAction{
  
     Gfloys aplet;																//premenna celeho appletu (dialogu)
  	
  public NastavitToroid(Gfloys aplet)
    {
     super("EnviromentModelAction");
     this.aplet = aplet;
     	
    }	
  public void actionPerformed(ActionEvent e) 
    {	
		int i;
				for (i=0;i<NF;i++) {
						Gfloys[i].ohraniceny = false;
				}
		
    }
  }
  
  public class NastavitOhraniceny extends AbstractAction{
 
     Gfloys aplet;																//premenna celeho appletu (dialogu)
   	
   public NastavitOhraniceny(Gfloys aplet)
    {
     super("EnviromentModelAction");
     this.aplet = aplet;
     	
    }	
   public void actionPerformed(ActionEvent e) 
    {	
		int i;
				for (i=0;i<NF;i++) {
						Gfloys[i].ohraniceny = true;
				}
    }
  }  




   public class PocetAction implements ChangeListener {							//trieda oetrujuca slider Pocet jedincov
     Gfloys aplet;																//premenn celho appletu (dialogu)
     int count,i;
    public PocetAction(Gfloys aplet) 											//kontruktor triedy
      {
        super();
        this.aplet = aplet;
      }   	
   	
   	public void stateChanged(ChangeEvent e)
   	  {
   	   count = ((JSlider)e.getSource()).getValue();	
	stop();
	NF = count;
	First = true;
	ResetPopulation = true;
	Pause.setLabel("Pauza");
	start();

	   aplet.lbPocet.setText("Poet jedincov: "+count);   	  
   	  	
   	  }
   }	 


   public class RychlostAction implements ChangeListener {						//trieda osetrujuca slider Rychlost
      Gfloys aplet;															//premenna celeho appletu (dialogu)
     int speed;    
    
    public RychlostAction(Gfloys aplet) 										//konstruktor triedy
      {
        super();
        this.aplet = aplet;
      }   	
   	
   	public void stateChanged(ChangeEvent e)
   	  {
   	   speed = ((JSlider)e.getSource()).getValue();
   	   SLEEP = 100 - speed;
   	   aplet.lbRychlost.setText("Rchlos: "+ speed +"%"); 			
   	  }
   }	 

  public class PridatAction extends AbstractAction {							//trieda osetrujuca tlacitko Pridat
    
      Gfloys aplet;															//premenna celeho appletu (dialogu)
    
    public PridatAction(Gfloys aplet) 											//konstruktor triedy
      {
        super("PridatAction");
        this.aplet = aplet;
      }

    public void actionPerformed(ActionEvent e) 									//osetruje stlacenie tlacitka
      {
			Gfloys[0].type =1;
			Gfloys[0].color = Color.red;
			Gfloys[0].energy = 100;
			Gfloys[0].x = 10;
			Gfloys[0].y = 10;

      }
   
  }

  public class OdobratAction extends AbstractAction {							//trieda osetrujuca tlacitko Odobrat
    
      Gfloys aplet;															//premenna celeho appletu (dialogu)

    public OdobratAction(Gfloys aplet) 											//konstruktor triedy
      {
        super("OdobratAction");
        this.aplet = aplet;
      }

    public void actionPerformed(ActionEvent e) 									//osetruje stlacenie tlacitka
      {
			Gfloys[0].color = GetColorByString(COLOR);
			Gfloys[0].type = 0;
			Gfloys[0].energy = 100;
      }
   
  }

  public class DefaultAction extends AbstractAction {							//trieda osetrujuca tlacitko tandartn nastavenia
    
      Gfloys aplet;															//premenna celeho appletu (dialogu)
    
    public DefaultAction(Gfloys aplet) 											//konstruktor triedy
      {
        super("DefaultAction");
        this.aplet = aplet;
      }

    public void actionPerformed(ActionEvent e) 									//osetruje stlacenie tlacitka
      {
 	    aplet.sldRychlost.setValue(80);
 	    aplet.sldPocet.setValue(10);
 	    cmbSpravanie.setSelectedItem("tandartn sprvanie");
 	    ChangeBehavior(0);

			Gfloys[0].type = 0;
			Gfloys[0].color = Color.black;
			Gfloys[0].energy = 100;

			reset();
			stop();
			First = true;
            aplet.lbStatus.setText("tandartn sprvanie");   	  
			showStatus("tandartn sprvanie");
			start();
      }
   
  }

  public class ControlAction extends AbstractAction {							//trieda osetrujuca tlacitko Vlastnosti
    
      Gfloys aplet;															//premenna celeho appletu (dialogu)
    
    public ControlAction(Gfloys aplet) 											//konstruktor triedy
      {
        super("ControlAction");
        this.aplet = aplet;
      }

    public void actionPerformed(ActionEvent e) 									//osetruje stlacenie tlacitka
      {
			stop();
			Pause.setLabel("Pokrauj");
			canvas.Clear();
			fcontrol = new GfloyControl(Gfloys);
			showStatus("Uvatesk sprvanie");
      }
   
  }

 


  public class PauseAction extends AbstractAction {							//trieda osetrujuca tlacitko Pauza
    
      Gfloys aplet;															//premenna celeho appletu (dialogu)
    
    public PauseAction(Gfloys aplet) 											//konstruktor triedy
      {
        super("PauseAction");
        this.aplet = aplet;
      }

    public void actionPerformed(ActionEvent e) 									//osetruje stlacenie tlacitka
      {
      	if (running) {
				stop();
				running = false;
				Pause.setLabel("Pokrauj");
			}
			else {
				start();
				running = true;
				Pause.setLabel("Pauza");
			}
			
		}
      }



	public boolean handleEvent(Event evt) {

		if(evt.id == Event.WINDOW_DESTROY) {
			showStatus("Okno zatvoren");
			destroy();
			System.exit(0);
		}

		return super.handleEvent(evt);
	}


	private void ScrollbarPanel() {
		ControlPanel = new Panel();
		ControlPanel.setLayout(new GridLayout(2,4));
		Label l1 = new Label("Poet Ifloyov");
		Label l2 = new Label("Kolzna vzdialenos");
		Label l3 = new Label("Zrchlenie");
		Label l4 = new Label("Lipnutie");
		Label l1a = new Label("");
		Label l2a = new Label("");
		Label l3a = new Label("");
		Label l4a = new Label("");
		Scrollbar b1 = new Scrollbar(Scrollbar.HORIZONTAL);
		Scrollbar b2 = new Scrollbar(Scrollbar.HORIZONTAL);
		Scrollbar b3 = new Scrollbar(Scrollbar.HORIZONTAL);
		Scrollbar b4 = new Scrollbar(Scrollbar.HORIZONTAL);
		ControlPanel.add(l1);
		ControlPanel.add(l2);
		ControlPanel.add(l3);
		ControlPanel.add(l4);
		ControlPanel.add(b1);
		ControlPanel.add(b2);
		ControlPanel.add(b3);
		ControlPanel.add(b4);
		add("North",ControlPanel);
	}


}




